## desmume 0.9.13

=== tools/ds_tests/matrixStack/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------

ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

include $(DEVKITARM)/ds_rules

#---------------------------------------------------------------------------------
# TARGET is the name of the output
# BUILD is the directory where object files & intermediate files will be placed
# SOURCES is a list of directories containing source code
# INCLUDES is a list of directories containing extra header files
#---------------------------------------------------------------------------------
TARGET		:=	$(shell basename $(CURDIR))
BUILD		:=	build
SOURCES		:=	source
DATA		:=	data  
INCLUDES	:=	include

#---------------------------------------------------------------------------------
# options for code generation
#---------------------------------------------------------------------------------
ARCH	:=	-mthumb -mthumb-interwork

CFLAGS	:=	-g -Wall -O2\
			-march=armv5te -mtune=arm946e-s \
			-ffast-math \
			$(ARCH)

CFLAGS	+=	$(INCLUDE) -DARM9
CXXFLAGS	:= $(CFLAGS)

ASFLAGS	:=	-g $(ARCH) -march=armv5te -mtune=arm946e-s
LDFLAGS	=	-specs=ds_arm9.specs -g $(ARCH) -Wl,-Map,$(notdir $*.map)

#---------------------------------------------------------------------------------
# any extra libraries we wish to link with the project
#---------------------------------------------------------------------------------
LIBS	:= -lfat -lnds9
 
 
#---------------------------------------------------------------------------------
# list of directories containing libraries, this must be the top level containing
# include and lib
#---------------------------------------------------------------------------------
LIBDIRS	:=	$(LIBNDS)
 
#---------------------------------------------------------------------------------
# no real need to edit anything past this point unless you need to add additional
# rules for different file extensions
#---------------------------------------------------------------------------------
ifneq ($(BUILD),$(notdir $(CURDIR)))
#---------------------------------------------------------------------------------
 
export OUTPUT	:=	$(CURDIR)/$(TARGET)
 
export VPATH	:=	$(foreach dir,$(SOURCES),$(CURDIR)/$(dir)) \
					$(foreach dir,$(DATA),$(CURDIR)/$(dir))

export DEPSDIR	:=	$(CURDIR)/$(BUILD)

CFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.c)))
CPPFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.cpp)))
SFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.s)))
BINFILES	:=	$(foreach dir,$(DATA),$(notdir $(wildcard $(dir)/*.*)))
 
#---------------------------------------------------------------------------------
# use CXX for linking C++ projects, CC for standard C
#---------------------------------------------------------------------------------
ifeq ($(strip $(CPPFILES)),)
#---------------------------------------------------------------------------------
	export LD	:=	$(CC)
#---------------------------------------------------------------------------------
else
#---------------------------------------------------------------------------------
	export LD	:=	$(CXX)
#---------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------

export OFILES	:=	$(addsuffix .o,$(BINFILES)) \
					$(CPPFILES:.cpp=.o) $(CFILES:.c=.o) $(SFILES:.s=.o)
 
export INCLUDE	:=	$(foreach dir,$(INCLUDES),-I$(CURDIR)/$(dir)) \
					$(foreach dir,$(LIBDIRS),-I$(dir)/include) \
					$(foreach dir,$(LIBDIRS),-I$(dir)/include) \
					-I$(CURDIR)/$(BUILD)
 
export LIBPATHS	:=	$(foreach dir,$(LIBDIRS),-L$(dir)/lib)
 
.PHONY: $(BUILD) clean
 
#---------------------------------------------------------------------------------
$(BUILD):
	@[ -d $@ ] || mkdir -p $@
	@make --no-print-directory -C $(BUILD) -f $(CURDIR)/Makefile
 
#---------------------------------------------------------------------------------
clean:
	@echo clean ...
	@rm -fr $(BUILD) $(TARGET).elf $(TARGET).nds $(TARGET).arm9
 
 
#---------------------------------------------------------------------------------
else
 
DEPENDS	:=	$(OFILES:.o=.d)
 
#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
$(OUTPUT).nds	: 	$(OUTPUT).arm9
$(OUTPUT).arm9	:	$(OUTPUT).elf
$(OUTPUT).elf	:	$(OFILES)
 
#---------------------------------------------------------------------------------
%.bin.o	:	%.bin
#---------------------------------------------------------------------------------
	@echo $(notdir $<)
	@$(bin2o)
 
 
-include $(DEPENDS)
 
#---------------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------------

=== tools/ds_tests/regs/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------
ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

include $(DEVKITARM)/ds_rules

export TARGET		:=	$(shell basename $(CURDIR))
export TOPDIR		:=	$(CURDIR)


.PHONY: $(TARGET).arm7 $(TARGET).arm9

#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
all: $(TARGET).nds

#---------------------------------------------------------------------------------
$(TARGET).nds	:	$(TARGET).arm7 $(TARGET).arm9
	ndstool	-c $(TARGET).nds -7 $(TARGET).arm7 -9 $(TARGET).arm9

#---------------------------------------------------------------------------------
$(TARGET).arm7	: arm7/$(TARGET).elf
$(TARGET).arm9	: arm9/$(TARGET).elf

#---------------------------------------------------------------------------------
arm7/$(TARGET).elf:
	$(MAKE) -C arm7
	
#---------------------------------------------------------------------------------
arm9/$(TARGET).elf:
	$(MAKE) -C arm9

#---------------------------------------------------------------------------------
clean:
	$(MAKE) -C arm9 clean
	$(MAKE) -C arm7 clean
	rm -f $(TARGET).nds $(TARGET).arm7 $(TARGET).arm9

=== tools/ds_tests/twltouch/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------
ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

include $(DEVKITARM)/ds_rules

export TARGET		:=	$(shell basename $(CURDIR))
export TOPDIR		:=	$(CURDIR)

PARAMS	:=	 
ifeq ($(USETWLSDMMC),1)
PARAMS	+=	USETWLSDMMC=1
endif

.PHONY: arm7/$(TARGET).elf arm9/$(TARGET).elf

#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
all: $(TARGET).nds

#---------------------------------------------------------------------------------
$(TARGET).nds	:	arm7/$(TARGET).elf arm9/$(TARGET).elf
	ndstool	-c $(TARGET).nds -7 arm7/$(TARGET).elf -9 arm9/$(TARGET).elf

#---------------------------------------------------------------------------------
arm7/$(TARGET).elf:
	$(MAKE) -C arm7 $(PARAMS)
	
#---------------------------------------------------------------------------------
arm9/$(TARGET).elf:
	$(MAKE) -C arm9 $(PARAMS)

#---------------------------------------------------------------------------------
clean:
	$(MAKE) -C arm9 clean
	$(MAKE) -C arm7 clean
	rm -f $(TARGET).nds $(TARGET).arm7 $(TARGET).arm9

=== desmume/src/frontend/interface/meson_options.txt ===
option('openal',
  type: 'boolean',
  value: false,
  description: 'Enable experimental OpenAL microphone input',
)
option('frontend-gtk',
  type: 'boolean',
  value: true,
  description: 'Enable GTK frontend',
)
option('frontend-cli',
  type: 'boolean',
  value: true,
  description: 'Enable CLI frontend',
)
option('wifi',
  type: 'boolean',
  value: false,
  description: 'Enable wifi support',
)
option('gdb-stub',
  type: 'boolean',
  value: false,
  description: 'Enable gdb stub',
)

=== tools/ds_tests/regs/arm7/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------
ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

include $(DEVKITARM)/ds_rules

#---------------------------------------------------------------------------------
# BUILD is the directory where object files & intermediate files will be placed
# SOURCES is a list of directories containing source code
# INCLUDES is a list of directories containing extra header files
# DATA is a list of directories containing binary files
# all directories are relative to this makefile
#---------------------------------------------------------------------------------
BUILD		:=	build
SOURCES		:=	source  
INCLUDES	:=	include build
DATA		:=
 
#---------------------------------------------------------------------------------
# options for code generation
#---------------------------------------------------------------------------------
ARCH	:=	-mthumb-interwork

CFLAGS	:=	-g -Wall -O2\
		-mcpu=arm7tdmi -mtune=arm7tdmi -fomit-frame-pointer\
		-ffast-math \
		$(ARCH)

CFLAGS	+=	$(INCLUDE) -DARM7
CXXFLAGS	:=	$(CFLAGS) -fno-rtti -fno-exceptions -fno-rtti


ASFLAGS	:=	-g $(ARCH)
LDFLAGS	=	-specs=ds_arm7.specs -g $(ARCH) -Wl,-Map,$(notdir $*).map

LIBS	:=	-ldswifi7 -lmm7 -lnds7

#---------------------------------------------------------------------------------
# list of directories containing libraries, this must be the top level containing
# include and lib
#---------------------------------------------------------------------------------
LIBDIRS	:=	$(LIBNDS)
 
  
#---------------------------------------------------------------------------------
# no real need to edit anything past this point unless you need to add additional
# rules for different file extensions
#---------------------------------------------------------------------------------
ifneq ($(BUILD),$(notdir $(CURDIR)))
#---------------------------------------------------------------------------------
 
export ARM7BIN	:=	$(TOPDIR)/$(TARGET).arm7
export ARM7ELF	:=	$(CURDIR)/$(TARGET).arm7.elf
export DEPSDIR	:=	$(CURDIR)/$(BUILD)

export VPATH	:=	$(foreach dir,$(SOURCES),$(CURDIR)/$(dir))
 
CFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.c)))
CPPFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.cpp)))
SFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.s)))
BINFILES	:=	$(foreach dir,$(DATA),$(notdir $(wildcard $(dir)/*.*)))
 
export OFILES	:=	$(addsuffix .o,$(BINFILES)) \
			$(CPPFILES:.cpp=.o) $(CFILES:.c=.o) $(SFILES:.s=.o)
 
export INCLUDE	:=	$(foreach dir,$(INCLUDES),-I$(CURDIR)/$(dir)) \
			$(foreach dir,$(LIBDIRS),-I$(dir)/include) \
			-I$(CURDIR)/$(BUILD)
 
export LIBPATHS	:=	$(foreach dir,$(LIBDIRS),-L$(dir)/lib)

#---------------------------------------------------------------------------------
# use CXX for linking C++ projects, CC for standard C
#---------------------------------------------------------------------------------
ifeq ($(strip $(CPPFILES)),)
#---------------------------------------------------------------------------------
	export LD	:=	$(CC)
#---------------------------------------------------------------------------------
else
#---------------------------------------------------------------------------------
	export LD	:=	$(CXX)
#---------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------

.PHONY: $(BUILD) clean
 
#---------------------------------------------------------------------------------
$(BUILD):
	@[ -d $@ ] || mkdir -p $@
	@make --no-print-directory -C $(BUILD) -f $(CURDIR)/Makefile
 
#---------------------------------------------------------------------------------
clean:
	@echo clean ...
	@rm -fr $(BUILD) *.elf
 
 
#---------------------------------------------------------------------------------
else
 
DEPENDS	:=	$(OFILES:.o=.d)
 
#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
$(ARM7BIN)	:	$(ARM7ELF)
	@$(OBJCOPY) -O binary $< $@
	@echo built ... $(notdir $@)


$(ARM7ELF)	:	$(OFILES)
	@echo linking $(notdir $@)
	@$(LD)  $(LDFLAGS) $(OFILES) $(LIBPATHS) $(LIBS) -o $@


#---------------------------------------------------------------------------------
# you need a rule like this for each extension you use as binary data 
#---------------------------------------------------------------------------------
%.bin.o	:	%.bin
#---------------------------------------------------------------------------------
	@echo $(notdir $<)
	@$(bin2o)

-include $(DEPENDS)
 
#---------------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------------

=== tools/ds_tests/regs/arm9/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------
ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

include $(DEVKITARM)/ds_rules

#---------------------------------------------------------------------------------
# BUILD is the directory where object files & intermediate files will be placed
# SOURCES is a list of directories containing source code
# INCLUDES is a list of directories containing extra header files
# DATA is a list of directories containing binary files
# all directories are relative to this makefile
#---------------------------------------------------------------------------------
BUILD		:=	build
SOURCES		:=	source  
INCLUDES	:=	include
DATA		:=


#---------------------------------------------------------------------------------
# options for code generation
#---------------------------------------------------------------------------------
ARCH	:=	-mthumb -mthumb-interwork

CFLAGS	:=	-g -Wall -O2\
 			-march=armv5te -mtune=arm946e-s -fomit-frame-pointer\
			-ffast-math \
			$(ARCH)

CFLAGS	+=	$(INCLUDE) -DARM9
CXXFLAGS	:=	$(CFLAGS) -fno-rtti -fno-exceptions

ASFLAGS	:=	-g $(ARCH) -march=armv5te -mtune=arm946e-s

LDFLAGS	=	-specs=ds_arm9.specs -g $(ARCH) -Wl,-Map,$(notdir $*.map)

#---------------------------------------------------------------------------------
# any extra libraries we wish to link with the project
#---------------------------------------------------------------------------------
LIBS	:=	-lnds9
 
#---------------------------------------------------------------------------------
# list of directories containing libraries, this must be the top level containing
# include and lib
#---------------------------------------------------------------------------------
LIBDIRS	:=	$(LIBNDS)
 
#---------------------------------------------------------------------------------
# no real need to edit anything past this point unless you need to add additional
# rules for different file extensions
#---------------------------------------------------------------------------------
ifneq ($(BUILD),$(notdir $(CURDIR)))
#---------------------------------------------------------------------------------
 
export ARM9BIN	:=	$(TOPDIR)/$(TARGET).arm9
export ARM9ELF	:=	$(CURDIR)/$(TARGET).arm9.elf
export DEPSDIR := $(CURDIR)/$(BUILD)

export VPATH	:=	$(foreach dir,$(SOURCES),$(CURDIR)/$(dir)) \
					$(foreach dir,$(DATA),$(CURDIR)/$(dir))
 
CFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.c)))
CPPFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.cpp)))
SFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.s)))
BINFILES	:=	$(foreach dir,$(DATA),$(notdir $(wildcard $(dir)/*.*)))
 
#---------------------------------------------------------------------------------
# use CXX for linking C++ projects, CC for standard C
#---------------------------------------------------------------------------------
ifeq ($(strip $(CPPFILES)),)
#---------------------------------------------------------------------------------
	export LD	:=	$(CC)
#---------------------------------------------------------------------------------
else
#---------------------------------------------------------------------------------
	export LD	:=	$(CXX)
#---------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------

export OFILES	:=	$(addsuffix .o,$(BINFILES)) \
					$(CPPFILES:.cpp=.o) $(CFILES:.c=.o) $(SFILES:.s=.o)
 
export INCLUDE	:=	$(foreach dir,$(INCLUDES),-I$(CURDIR)/$(dir)) \
			$(foreach dir,$(LIBDIRS),-I$(dir)/include) \
			-I$(CURDIR)/$(BUILD)
 
export LIBPATHS	:=	$(foreach dir,$(LIBDIRS),-L$(dir)/lib)
 
.PHONY: $(BUILD) clean
 
#---------------------------------------------------------------------------------
$(BUILD):
	@[ -d $@ ] || mkdir -p $@
	@$(MAKE) --no-print-directory -C $(BUILD) -f $(CURDIR)/Makefile
 
#---------------------------------------------------------------------------------
clean:
	@echo clean ...
	@rm -fr $(BUILD) *.elf *.nds* *.bin 
 
 
#---------------------------------------------------------------------------------
else
 
#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
$(ARM9BIN)	:	$(ARM9ELF)
	@$(OBJCOPY) -O binary $< $@
	@echo built ... $(notdir $@)

$(ARM9ELF)	:	$(OFILES)
	@echo linking $(notdir $@)
	@$(LD)  $(LDFLAGS) $(OFILES) $(LIBPATHS) $(LIBS) -o $@

#---------------------------------------------------------------------------------
# you need a rule like this for each extension you use as binary data 
#---------------------------------------------------------------------------------
%.bin.o	:	%.bin
#---------------------------------------------------------------------------------
	@echo $(notdir $<)
	@$(bin2o)

-include $(DEPSDIR)/*.d
 
#---------------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------------

=== tools/ds_tests/twltouch/arm7/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------
ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

include $(DEVKITARM)/ds_rules

#---------------------------------------------------------------------------------
# BUILD is the directory where object files & intermediate files will be placed
# SOURCES is a list of directories containing source code
# INCLUDES is a list of directories containing extra header files
# DATA is a list of directories containing binary files
# all directories are relative to this makefile
#---------------------------------------------------------------------------------
BUILD		:=	build
SOURCES		:=	source  
INCLUDES	:=	include build
DATA		:=
 
DEFINES	:=	 
ifeq ($(USETWLSDMMC),1)
DEFINES	+=	-DUSETWLSDMMC
endif

#---------------------------------------------------------------------------------
# options for code generation
#---------------------------------------------------------------------------------
ARCH	:=	-mthumb-interwork

CFLAGS	:=	-g -Wall -O2\
		-mcpu=arm7tdmi -mtune=arm7tdmi -fomit-frame-pointer\
		-ffast-math \
		$(ARCH)

CFLAGS	+=	$(INCLUDE) -DARM7 $(DEFINES)
CXXFLAGS	:=	$(CFLAGS) -fno-rtti -fno-exceptions -fno-rtti


ASFLAGS	:=	-g $(ARCH)
LDFLAGS	=	-specs=ds_arm7.specs -g $(ARCH) -Wl,-Map,$(notdir $*).map

LIBS	:=	
ifeq ($(USETWLSDMMC),1)
LIBS	+=	-ltwlsdmmc7
endif
LIBS	+=	-ldswifi7 -lmm7 -lnds7

#---------------------------------------------------------------------------------
# list of directories containing libraries, this must be the top level containing
# include and lib
#---------------------------------------------------------------------------------
LIBDIRS	:=	$(LIBNDS)
 
  
#---------------------------------------------------------------------------------
# no real need to edit anything past this point unless you need to add additional
# rules for different file extensions
#---------------------------------------------------------------------------------
ifneq ($(BUILD),$(notdir $(CURDIR)))
#---------------------------------------------------------------------------------
 
export ARM7ELF	:=	$(CURDIR)/$(TARGET).elf
export DEPSDIR	:=	$(CURDIR)/$(BUILD)

export VPATH	:=	$(foreach dir,$(SOURCES),$(CURDIR)/$(dir))
 
CFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.c)))
CPPFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.cpp)))
SFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.s)))
BINFILES	:=	$(foreach dir,$(DATA),$(notdir $(wildcard $(dir)/*.*)))
 
export OFILES	:=	$(addsuffix .o,$(BINFILES)) \
			$(CPPFILES:.cpp=.o) $(CFILES:.c=.o) $(SFILES:.s=.o)
 
export INCLUDE	:=	$(foreach dir,$(INCLUDES),-I$(CURDIR)/$(dir)) \
			$(foreach dir,$(LIBDIRS),-I$(dir)/include) \
			-I$(CURDIR)/$(BUILD)
 
export LIBPATHS	:=	$(foreach dir,$(LIBDIRS),-L$(dir)/lib)

#---------------------------------------------------------------------------------
# use CXX for linking C++ projects, CC for standard C
#---------------------------------------------------------------------------------
ifeq ($(strip $(CPPFILES)),)
#---------------------------------------------------------------------------------
	export LD	:=	$(CC)
#---------------------------------------------------------------------------------
else
#---------------------------------------------------------------------------------
	export LD	:=	$(CXX)
#---------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------

.PHONY: $(BUILD) clean
 
#---------------------------------------------------------------------------------
$(BUILD):
	@[ -d $@ ] || mkdir -p $@
	@make --no-print-directory -C $(BUILD) -f $(CURDIR)/Makefile
 
#---------------------------------------------------------------------------------
clean:
	@echo clean ...
	@rm -fr $(BUILD) *.elf
 
 
#---------------------------------------------------------------------------------
else
 
DEPENDS	:=	$(OFILES:.o=.d)
 
#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
$(ARM7ELF)	:	$(OFILES)
	@echo linking $(notdir $@)
	@$(LD)  $(LDFLAGS) $(OFILES) $(LIBPATHS) $(LIBS) -o $@


#---------------------------------------------------------------------------------
# you need a rule like this for each extension you use as binary data 
#---------------------------------------------------------------------------------
%.bin.o	:	%.bin
#---------------------------------------------------------------------------------
	@echo $(notdir $<)
	@$(bin2o)

-include $(DEPENDS)
 
#---------------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------------

=== tools/ds_tests/twltouch/arm9/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------
ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

include $(DEVKITARM)/ds_rules

#---------------------------------------------------------------------------------
# BUILD is the directory where object files & intermediate files will be placed
# SOURCES is a list of directories containing source code
# INCLUDES is a list of directories containing extra header files
# DATA is a list of directories containing binary files
# all directories are relative to this makefile
#---------------------------------------------------------------------------------
BUILD		:=	build
SOURCES		:=	source  
INCLUDES	:=	include
DATA		:=


#---------------------------------------------------------------------------------
# options for code generation
#---------------------------------------------------------------------------------
ARCH	:=	-mthumb -mthumb-interwork

CFLAGS	:=	-g -Wall -O2\
 			-march=armv5te -mtune=arm946e-s -fomit-frame-pointer\
			-ffast-math \
			$(ARCH)

CFLAGS	+=	$(INCLUDE) -DARM9
CXXFLAGS	:=	$(CFLAGS) -fno-rtti -fno-exceptions

ASFLAGS	:=	-g $(ARCH) -march=armv5te -mtune=arm946e-s

LDFLAGS	=	-specs=ds_arm9.specs -g $(ARCH) -Wl,-Map,$(notdir $*.map)

#---------------------------------------------------------------------------------
# any extra libraries we wish to link with the project
#---------------------------------------------------------------------------------
LIBS	:=	-lnds9
 
#---------------------------------------------------------------------------------
# list of directories containing libraries, this must be the top level containing
# include and lib
#---------------------------------------------------------------------------------
LIBDIRS	:=	$(LIBNDS)
 
#---------------------------------------------------------------------------------
# no real need to edit anything past this point unless you need to add additional
# rules for different file extensions
#---------------------------------------------------------------------------------
ifneq ($(BUILD),$(notdir $(CURDIR)))
#---------------------------------------------------------------------------------
 
export ARM9ELF	:=	$(CURDIR)/$(TARGET).elf
export DEPSDIR := $(CURDIR)/$(BUILD)

export VPATH	:=	$(foreach dir,$(SOURCES),$(CURDIR)/$(dir)) \
					$(foreach dir,$(DATA),$(CURDIR)/$(dir))
 
CFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.c)))
CPPFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.cpp)))
SFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.s)))
BINFILES	:=	$(foreach dir,$(DATA),$(notdir $(wildcard $(dir)/*.*)))
 
#---------------------------------------------------------------------------------
# use CXX for linking C++ projects, CC for standard C
#---------------------------------------------------------------------------------
ifeq ($(strip $(CPPFILES)),)
#---------------------------------------------------------------------------------
	export LD	:=	$(CC)
#---------------------------------------------------------------------------------
else
#---------------------------------------------------------------------------------
	export LD	:=	$(CXX)
#---------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------

export OFILES	:=	$(addsuffix .o,$(BINFILES)) \
					$(CPPFILES:.cpp=.o) $(CFILES:.c=.o) $(SFILES:.s=.o)
 
export INCLUDE	:=	$(foreach dir,$(INCLUDES),-I$(CURDIR)/$(dir)) \
			$(foreach dir,$(LIBDIRS),-I$(dir)/include) \
			-I$(CURDIR)/$(BUILD)
 
export LIBPATHS	:=	$(foreach dir,$(LIBDIRS),-L$(dir)/lib)
 
.PHONY: $(BUILD) clean
 
#---------------------------------------------------------------------------------
$(BUILD):
	@[ -d $@ ] || mkdir -p $@
	@$(MAKE) --no-print-directory -C $(BUILD) -f $(CURDIR)/Makefile
 
#---------------------------------------------------------------------------------
clean:
	@echo clean ...
	@rm -fr $(BUILD) *.elf *.nds* *.bin 
 
 
#---------------------------------------------------------------------------------
else
 
#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
$(ARM9ELF)	:	$(OFILES)
	@echo linking $(notdir $@)
	@$(LD)  $(LDFLAGS) $(OFILES) $(LIBPATHS) $(LIBS) -o $@

#---------------------------------------------------------------------------------
# you need a rule like this for each extension you use as binary data 
#---------------------------------------------------------------------------------
%.bin.o	:	%.bin
#---------------------------------------------------------------------------------
	@echo $(notdir $<)
	@$(bin2o)

-include $(DEPSDIR)/*.d
 
#---------------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------------

=== desmume/src/libretro-common/net/test/Makefile ===
TARGETS  = http_test net_ifinfo

LIBRETRO_COMM_DIR := ../..

INCFLAGS = -I$(LIBRETRO_COMM_DIR)/include

ifeq ($(DEBUG),1)
CFLAGS += -O0 -g
else
CFLAGS += -O2
endif
CFLAGS += -Wall -pedantic -std=gnu99

HTTP_TEST_C = \
				  $(LIBRETRO_COMM_DIR)/net/net_http.c \
				  net_http_test.c \
				  $(LIBRETRO_COMM_DIR)/net/net_compat.c \
				  $(LIBRETRO_COMM_DIR)/compat/compat_strl.c

HTTP_TEST_OBJS := $(HTTP_TEST_C:.c=.o)

NET_IFINFO_C = \
					$(LIBRETRO_COMM_DIR)/net/net_ifinfo.c \
					net_ifinfo_test.c

NET_IFINFO_OBJS := $(NET_IFINFO_C:.c=.o)

.PHONY: all clean

all: $(TARGETS)

%.o: %.c
	$(CC) $(INCFLAGS) $< -c $(CFLAGS) -o $@

http_test: $(HTTP_TEST_OBJS)
	$(CC) $(INCFLAGS) $(HTTP_TEST_OBJS) $(CFLAGS) -o $@

net_ifinfo: $(NET_IFINFO_OBJS)
	$(CC) $(INCFLAGS) $(NET_IFINFO_OBJS) $(CFLAGS) -o $@

clean:
	rm -rf $(TARGETS) $(HTTP_TEST_OBJS) $(NET_IFINFO_OBJS)

## desmume 0.9.6-1%2br3654-1

=== debian/changelog ===
desmume (0.9.6-1+r3654-1) fremantle; urgency=low

  * Updated sources to SVN r3654
  * Hildonized GTK UI

 -- Tomasz Sterna <tomek@xiaoka.com>  Sun, 30 May 2010 22:00:27 +0200

desmume (0.9.6-1+r3653-1) karmic; urgency=low

  * Maemo Edition forked
  * Updated sources to SVN r3653

 -- Tomasz Sterna <tomek@xiaoka.com>  Fri, 28 May 2010 02:06:13 +0200

desmume-trunk (svnrivisionr3508) karmic; urgency=low

  [ zeromus ]
  * debug: get rid of excessive "Reading beyond end of cart" messages
    git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    18 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * fix swi 0x0E (crc16); your dawn of sorrow savefiles are invalidated.
    git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    19 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ mtabachenko ]
  * core: - fix overflow in matrices, NDS using only 24 bits for fixed-
    point numbers (fixed minigame with carrot :) and dialogs with star
    in "M&L Bowser Inside Story"); tools: - add matrix stack test; git-
    svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    20 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ zeromus ]
  * rasterize: fix fog densities > 127 git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    21 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * tweak around lcd line timing: make 3d vblank more generous (is still
    unrealistically brutal since all the rendering happens
    instantaneously, unlike real HW); give scanlines more time to render
    (render at end of scanline instead of hblank begin); execute an
    additional hblank dma on vcount=262 (speculative; fixes jittery nsmb
    split-parallax clouds) git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    22 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * fix dualscreen 3d frameskip screen cloning/flickering regression
    from r3422 git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    23 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ yoshihiropsp ]
  * Added xbox360 support by Yoshihiro git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    24 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ mtabachenko ]
  * - x360 port directory; git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    25 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * - move xbox360 stuff to new directory; git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    26 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ yoshihiropsp ]
  * Added xbox360 support on desmume git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    27 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    28 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    29 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * Added xbox360 support to desmume Yoshihiro git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    30 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    31 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * Added some define for the xbox360 support git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    32 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    33 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * Version string fixed for XBox360 new def git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    34 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    35 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * Big endian argb git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    36 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ yabause ]
  * Reverting the whole tree to revision 3423, please test to make sure
    everything is back :) git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    37 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ yoshihiropsp ]
  * Added XBOX360 support for compactflash git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    38 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * Add _XBOX undefined git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    39 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * #undef min max for XBOX360 git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    40 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * Fixed GFX3D reset on xbox hardware #define _XBOX git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    41 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * Added Forceinline fix on XBOX360 cannot be used with static git-svn-
    id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    42 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * Added XBOX include git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    43 5577840e-afb3-4e59-9ef3-2b7f898b1952
  * #undef min max and fix forceinline for XBOX360 git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    44 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ zeromus ]
  * check in all the xbox compile fixes after tweaking some things.
    looks benign. need to test compilation in nix still git-svn-id:
    https://desmume.svn.sourceforge.net/svnroot/desmume/trunk/desmume@34
    45 5577840e-afb3-4e59-9ef3-2b7f898b1952

  [ yoshihiropsp ]
  * Xbox Project git-svn-id:


=== debian/control ===
Source: desmume
Section: user/games
Priority: extra
Maintainer: Tomasz Sterna <tomek@xiaoka.com>
Build-Depends: debhelper (>= 5), libgtk2.0-dev, libsdl1.2-dev,
 libhildon1-dev, libhildonfm2-dev, libosso-dev,
 libagg-dev, intltool, quilt, libasound2-dev, desktop-file-utils
Standards-Version: 3.8.3
Vcs-Git: git://github.com/smokku/desmume.git
Vcs-Browser: http://github.com/smokku/desmume
Homepage: http://desmume.org/

Package: desmume
Architecture: any
Depends: ${shlibs:Depends}, desktop-file-utils
Description: Nintendo DS emulator
 DeSmuME is a Nintendo DS emulator running homebrew demos and commercial games.
XSBC-Bugtracker: http://github.com/smokku/desmume/issues
XB-Maemo-Display-Name: DeSmuME
XB-Maemo-Icon-26:
 LyogWFBNICovCnN0YXRpYyBjb25zdCBjaGFyICogRGVTbXVNRV94cG1bXSA9
 IHsKIjMyIDMyIDE1IDEiLAoiIAljIE5vbmUiLAoiLgljICMwMDAwMDAiLAoi
 KwljICNGNkY2RkIiLAoiQAljICNFQ0VDRjYiLAoiIwljICNFMkUyRjEiLAoi
 JAljICNEOEQ4RUMiLAoiJQljICNDRkNGRTciLAoiJgljICNDNUM1RTIiLAoi
 KgljICNCQkJCREUiLAoiPQljICNCMUIxRDkiLAoiLQljICNBOEE4RDQiLAoi
 OwljICM5RTlFQ0YiLAoiPgljICM5NDk0Q0EiLAoiLAljICM4QThBQzUiLAoi
 JwljICM4MDgwQzAiLAoiICAgLi4uLi4uLi4uLi4uLi4uLi4uLi4gICAgICAg
 ICAiLAoiICAgLi4uLi4uLi4uLi4uLi4uLi4uLi4gICAgICAgICAiLAoiLi4u
 Li4rKy4uKysrKysuLisrKysrLi4gICAgICAgICAiLAoiLi4uLi4rKy4uKysu
 Li4uLisrLi4uLi4gICAgICAgICAiLAoiLi5AQEBAQC4uQEBAQEAuLkBAQEBA
 Li4gICAgICAgICAiLAoiLi5AQC5AQC4uQEAuLi4uLi4uLkBALi4gICAgICAg
 ICAiLAoiLi4jIy4jIy4uIyMuIyMuLiMjLiMjLi4gICAgICAgICAiLAoiLi4j
 Iy4jIy4uIyMuIyMuLiMjLiMjLi4gICAgICAgICAiLAoiLi4kJC4kJC4uJCQu
 JCQuLiQkLiQkLi4gICAgICAgICAiLAoiLi4kJC4kJC4uJCQuJCQuLiQkLiQk
 Li4gICAgICAgICAiLAoiLi4lJS4lJS4uJSUuJSUuLiUlLiUlLi4gICAgICAg
 ICAiLAoiLi4lJS4lJS4uJSUuJSUuLiUlLiUlLi4gICAgICAgICAiLAoiLi4m
 JiYmJi4uJiYmJiYuLiYmJiYmLi4gICAgICAgICAiLAoiLi4uLi4uLi4uLi4u
 Li4uLi4uLi4uLi4gICAgICAgICAiLAoiLi4uLi4uLioqKioqKioqLioqLioq
 Li4gICAgICAgICAiLAoiICAgICAuLj09Lj09Lj09Lj09Lj09Li4gICAgICAg
 ICAiLAoiICAgICAuLj09Lj09Lj09Lj09Lj09Li4gICAgICAgICAiLAoiICAg
 ICAuLi0tLi0tLi0tLi0tLi0tLi4gICAgICAgICAiLAoiICAgICAuLi0tLi0t
 Li0tLi0tLi0tLi4gICAgICAgICAiLAoiICAgICAuLjs7Ljs7Ljs7Ljs7Ozs7
 Li4gICAgICAgICAiLAoiICAgICAuLi4uLi4uLi4uLi4uLi4uLi4uLi4gICAg
 ICAiLAoiICAgICAuLi4uLi4uLi4uLi4uLi4uLi4uLi4gICAgICAiLAoiICAg
 ICAgICAuLj4+Pj4+Pj4+Lj4+Pj4+Li4gICAgICAiLAoiICAgICAgICAuLj4+
 Lj4+Lj4+Lj4+Li4uLi4gICAgICAiLAoiICAgICAgICAuLiwsLiwsLiwsLiws
 LCwsLi4gICAgICAiLAoiICAgICAgICAuLiwsLiwsLiwsLiwsLi4uLi4gICAg
 ICAiLAoiICAgICAgICAuLicnLicnLicnLicnLicnLi4gICAgICAiLAoiICAg
 ICAgICAuLicnLicnLicnLicnLicnLi4gICAgICAiLAoiICAgICAgICAuLicn
 LicnLicnLicnLicnLi4gICAgICAiLAoiICAgICAgICAuLicnLicnLicnLicn
 JycnLi4gICAgICAiLAoiICAgICAgICAuLi4uLi4uLi4uLi4uLi4uLi4gICAg
 ICAiLAoiICAgICAgICAuLi4uLi4uLi4uLi4uLi4uLi4gICAgICAifTsK

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/quilt/quilt.make

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

configure_flags = --prefix=/usr --mandir=\$${prefix}/share/man \
			--bindir=/usr/games --datadir=/usr/share/games \
			--localedir=/usr/share/locale \
			--enable-gdb-stub --enable-hildon

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  configure_flags += --build $(DEB_HOST_GNU_TYPE)
else
  configure_flags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

configure:
	autoreconf -f -i
	intltoolize

config.status: configure
	dh_testdir
	# Update config.{guess,sub}
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	./configure $(configure_flags) \
		CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs -Wl,--as-needed"

build: $(QUILT_STAMPFN) build-stamp

build-stamp:  config.status
	dh_testdir
	$(MAKE)
	touch $@

clean: unpatch
	dh_testdir
	dh_testroot
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean config.guess config.sub build-stamp 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/desmume install
	mv debian/desmume/usr/share/games/pixmaps/DeSmuME.xpm \
		debian/desmume/usr/share/pixmaps/
	rm -rf debian/desmume/usr/share/games/pixmaps
	mv debian/desmume/usr/share/games/applications/desmume*.desktop \
		debian/desmume/usr/share/applications/hildon/
	rm -rf debian/desmume/usr/share/games/applications
	mv debian/desmume/usr/share/games/dbus-1/services/desmume.service \
		debian/desmume/usr/share/dbus-1/services
	rm -rf debian/desmume/usr/share/games/dbus-1
	rm -f debian/desmume/usr/games/*glade* debian/desmume/usr/share/applications/hildon/*glade* debian/desmume/usr/share/man/man?/*glade*
	rm -rf debian/desmume/usr/share/games/desmume

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	#dh_installmenu
	#dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	maemo-optify
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
